package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.highlevel.controller.JFedHighLevelException;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.highlevel.util.AggregateManagerWrapperFactory;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.AggregateManagerWrapper;
import be.iminds.ilabt.jfed.util.common.GeniUrn;

import javax.annotation.Nonnull;
import java.util.Collections;
import java.util.List;

public class RestartTask extends PoaTask {
    public RestartTask(@Nonnull Slice slice,
                       @Nonnull Server auth,
                       @Nonnull GeniUrn poaTarget,
                       @Nonnull AggregateManagerWrapperFactory aggregateManagerWrapperFactory,
                       @Nonnull HighLevelTaskFactory highLevelTaskFactory) {
        super("Restart " + poaTarget, slice, auth, poaTarget, aggregateManagerWrapperFactory, highLevelTaskFactory);
    }

    @Override
    public void doPoaAction(@Nonnull AggregateManagerWrapper amWrapper) throws JFedException {
        if (!amWrapper.isRestartSupported())
            throw new JFedHighLevelException("Authority " + auth.getDefaultComponentManagerUrn() + " does not support restart.");
        amWrapper.restart(poaTarget, slice.getCredentials());
    }
}
